Option RTC On

Dim tgtDOW as Byte
Dim DOW as Byte
Dim dayNum as UnsignedInteger
Dim fail as Boolean
Dim done as Boolean
Dim initialized as Boolean = False
Dim dotCnt as Byte

Sub Main()
	Dim year as UnsignedInteger
	Dim month as Byte
	Dim day as Byte
	If (Not initialized) Then
		Call Sleep(1.0)
		Debug.Print
		Debug.Print "Starting!"

		Call PutDate(2019, 03, 12)
		Call GetDate(year, month, day)
		Debug.Print year; "/"; month; "/"; day; ", DOW is "; GetDayOfWeek(); " day number is "; GetDayNumber()

		' perform the required initialization
		dayNum = 0		' 01 Jan 1999
		tgtDOW = 6		' which was Friday
		initialized = TRUE
		dotCnt = 0
	ElseIf (Not Done And Not fail) Then
		' get the Day of Week corresponding to the day number
		dow = GetDayOfWeek(dayNum)

		' see if it matches the expected value
		If (DOW <> tgtDOW) Then
			
			' report the discrepancy
			Call GetDate(year, month, day, dayNum)
			If (dotCnt > 0) Then
				Debug.Print
			End If
			Debug.Print year; "/"; month; "/"; day; ", DOW is "; DOW; " s/b "; tgtDOW
			fail = TRUE
		ElseIf ((dayNum Mod 100) = 0) Then
			' every 100 days, output a dot; every 8000 days generate a new line
			Debug.Print ".";
			dotCnt = dotCnt + 1
			If (dotCnt = 80) Then
				dotCnt = 0
				Debug.Print
			End If
		End If

		' check for having tested all possible day numbers
		If (dayNum = &Hffff) Then
			done = True
			Debug.Print
			Debug.Print "Test completed"
		Else
			' prepare to test the next day number
			dayNum = dayNum + 1
			If (tgtDOW >= 7) Then
				tgtDOW = 1
			Else
				tgtDOW = tgtDOW + 1
			End If
		End If
	End If
End Sub
